<template>
    <v-container fluid>
        <v-card max-width="1200px" class="ma-auto">
            <v-card-title>Alert List</v-card-title>
            <v-data-table :headers="headers" :items="alerts" :items-per-page="20" :elevation="1">
                <template v-slot:item.alertLevel="{ item }">
                    {{item.alert.alertLevel.Capitalize()}}
                </template>

                <template v-slot:item.timeStamp="{ item }">
                    {{ ParseData(item.timeStamp)}}
                </template>

                <template v-slot:item.labels="{ item }">
                    <div>
                        <v-chip v-for="l in item.labels">
                            {{l}}
                        </v-chip>
                    </div>
                </template>

            </v-data-table>
        </v-card>
    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Prop} from 'vue-property-decorator';
    import {AlertPrincipalResponse} from "../../../../classLibrary/core/alertPrincipalResponse";
    import {Validable} from "../../mixins/Validable";
    import {Initializable} from "../../mixins/Initializable";
    import {Mixins} from "vue-mixin-decorator";
    import {RawLocation} from "vue-router";
    import {coreApi} from "../../init";
    import {BStorage} from "../../../../classLibrary/Storage";
    import moment from "moment";
    import "moment-timezone";

    interface AnalyticsMixin extends Validable, Initializable {
    }


    @Component
    export default class AlertList extends Mixins<AnalyticsMixin>(Validable, Initializable) {
        @Prop() store!: BStorage;

        alerts: AlertPrincipalResponse[] = [];

        headers = [
            {
                text: 'Title',
                align: 'center',
                sortable: false,
                value: 'alert.title',
            },
            {
                text: 'Message',
                align: 'start',
                sortable: false,
                value: 'alert.body',
            },

            {
                text: 'Alert Level',
                align: 'center',
                sortable: false,
                value: 'alert.alertLevel'
            },
            {
                text: 'Time',
                align: 'center',
                sortable: false,
                value: 'timeStamp',
            },
            {
                text: 'Labels',
                align: 'start',
                sortable: false,
                value: 'labels',
            },
            {
                text: 'Alert Type',
                align: 'center',
                sortable: false,
                value: 'alertType'
            },
        ]

        // Parameters
        before?: string;
        after?: string;
        searchTarget?: string;

        alertType?: 'Worker' | 'Zone';
        alertLevel?: 'information' | 'warning' | 'success' | 'error'

        ParseData(i: string): string {
            return moment(i).tz(this.store.value.tz).calendar()
        }

        updateQuery() {
            const route: RawLocation = {
                name: 'alerts',
                query: {}
            }

            if (!this.before?.IsEmpty()) route.query!['before'] = this.before;
            if (!this.after?.IsEmpty()) route.query!['after'] = this.after;
            if (!this.searchTarget?.IsEmpty()) route.query!['search'] = this.searchTarget;
            if (!this.alertLevel?.IsEmpty()) route.query!['alertLevel'] = this.alertLevel;
            if (!this.alertType?.IsEmpty()) route.query!['alertType'] = this.alertType;

        }

        loadQuery() {
            const query = this.$route.query;
            this.before = query.before as any;
            this.after = query.after as any;
            this.searchTarget = query.search as any;
            this.alertLevel = query.alertLevel as any;
            this.alertType = query.alertType as any;
        }

        async init() {
            this.loadQuery();
            const alertsResult = await coreApi.Get<AlertPrincipalResponse[]>('Alert');
            if (alertsResult.success) {
                this.alerts = alertsResult.Ok!;
            }
        }
    }
</script>
